package org.apache.maven;

/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2003 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" and
 *    "Apache Maven" must not be used to endorse or promote products
 *    derived from this software without prior written permission. For
 *    written permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    "Apache Maven", nor may "Apache" appear in their name, without
 *    prior written permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * ====================================================================
 */

import org.apache.maven.project.Dependency;

/**
 * 
 * @author <a href="michal.maczka@dimatics.com">Michal Maczka</a> 
 * @version $Id: DescribedDependency.java,v 1.1 2003/07/25 22:47:30 michal Exp $
 */
public class DescribedDependency implements Comparable
{
    private Dependency dependency;

    private String description = null;

    private String url = null;

    public DescribedDependency(Dependency dependency)
    {
        this.dependency = dependency;
    }

    /**
     * @see java.lang.Comparable#compareTo(java.lang.Object)
     */
    public int compareTo(Object obj)
    {
        DescribedDependency other = (DescribedDependency) obj;
        return this.getId().compareTo(other.getId()); 
    }
    /**
     * @return
     */
    public String getArtifact()
    {
        return dependency.getArtifact();
    }

    /**
     * @return
     */
    public String getArtifactDirectory()
    {
        return dependency.getArtifactDirectory();
    }

    /**
     * @return
     */
    public String getArtifactId()
    {
        return dependency.getArtifactId();
    }

    /**
     * @return
     */
    public String getExtension()
    {
        return dependency.getExtension();
    }

    /**
     * @return
     */
    public String getGroupId()
    {
        return dependency.getGroupId();
    }

    /**
     * @return
     */
    public String getId()
    {
        return dependency.getId();
    }

    /**
     * @return
     */
    public String getJar()
    {
        return dependency.getJar();
    }

    /**
     * @return
     */
    public String getName()
    {
        return dependency.getName();
    }

    /**
     * @return
     */
    public String getType()
    {
        return dependency.getType();
    }

    /**
     * 
     * @param url
     */
    public void setUrl(String url)
    {
        this.url = url;
    }

    /**
     * @return
     */
    public String getUrl()
    {
        String retValue = null;
        if (dependency.getUrl() != null && dependency.getUrl().length()>0)
        {
            retValue = dependency.getUrl();
        }
        else
        {

            return retValue = url;
        }
        return retValue;
    }

    /**
     * @return
     */
    public String getVersion()
    {
        return dependency.getVersion();
    }

    /**
    /**
     * @return
     */
    public String getDescription()
    {
        return description;
    }

    /**
     * @param description
     */
    public void setDescription(String description)
    {
        this.description = description;
    }

}
